/*
 * @Author       : ChenJie
 * @Date         : 2021-12-27 11:21:08
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2022-05-10 18:48:53
 * @Description  : file content
 * @FilePath     : \VehicleControl\VehicleControl\src\System\Vehicle\Communication\CanVar.h
 */
/*
 * CanVar.h
 *
 *  Created on: 20211227
 *  
 *      Author: QiXiang_CHENJIE
 */

#ifndef SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_
#define SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_
#include "Std_Types.h"
#include "HardwareLib.h"
#include "AppVar.h"
/************************************************************
 *BCU->Ebc
 ************************************************************/
extern UINT32 BcuInTable[28];
extern BOOL BcuRxShortError[28];
extern BOOL BcuRxLongError[28];
extern UINT8 BcuRxErrorCounter[28];
extern UINT8 BcuRxFlag[28];
extern UINT8 BMS_ReqVIN;
extern UINT8 BMS_ReqHVOff;
extern UINT8 BMS_ProtocolEditionH;
extern UINT8 BMS_ProtocolEditionL;
extern UINT8 BMS_CharDevNum;
extern UINT8 BMS_FtPosRly;
extern UINT8 BMS_FtNegRly;
extern UINT8 BMS_FtPosCharRly1;
extern UINT8 BMS_FtNegCharRly1;
extern UINT8 BMS_FtPosCharRly2;
extern UINT8 BMS_FtNegCharRly2;
extern UINT8 BMS_FtHeatRly1;
extern UINT8 BMS_FtHeatRly2;
extern UINT8 BMS_StPosRly;
extern UINT8 BMS_StNegRly;
extern UINT8 BMS_StPreCharRly;
extern UINT8 BMS_StPosCharRly1;
extern UINT8 BMS_StNegCharRly1;
extern UINT8 BMS_StPosCharRly2;
extern UINT8 BMS_StNegCharRly2;
extern UINT8 BMS_FtAuxRelayWeld;
extern UINT8 BMS_BraOpenCirc;
extern UINT8 BMS_FtBackCharCurrOutLim;
extern UINT8 BMS_FtPosRlyOpen;
extern UINT8 BMS_FtNegRlyOpen;
extern UINT8 BMS_FtPosCharRly1Open;
extern UINT8 BMS_FtPosCharRly2Open;
extern UINT8 BMS_FtNegCharRly1Open;
extern UINT8 BMS_FtNegCharRly2Open;
extern UINT8 BMS_FtTMSContClose;
extern UINT8 BMS_FtTMSContOpen;
extern UINT8 BMS_FtTMS;
extern UINT8 BMS_Ft24VSpy;
extern UINT8 BMS_FtPACKSelfProt;
extern UINT8 BMS_FtCharSockTempOver;
extern UINT8 BMS_FtTempOutCtrl;
extern UINT8 BMS_StPosHeatRly;
extern UINT8 BMS_StNegHeatRly;
extern UINT8 BMS_CharSysNum;
extern UINT8 BMS_FtCode;
extern UINT8 BMS_ST1CheckSum;
extern UINT8 BMS_ST1Counter;
extern UINT8 BMS_Mode;
extern UINT8 BMS_AuxRlySt;
extern UINT8 BMS_BattBalaSt;
extern UINT8 BMS_CharGunSt;
extern UINT8 BMS_CharMode;
extern UINT8 BMS_CharSt;
extern UINT8 BMS_FtLvl;
extern UINT8 BMS_FtCellTempDiff;
extern UINT8 BMS_FtCellTempHigh;
extern UINT8 BMS_FtPACKOverVolt;
extern UINT8 BMS_FtPACKUndeVolt;
extern UINT8 BMS_FtSOCLow;
extern UINT8 BMS_FtCellOverVolt;
extern UINT8 BMS_FtCellUndeVolt;
extern UINT8 BMS_FtIns;
extern UINT8 BMS_FtCellOverVoltDiff;
extern UINT8 BMS_FtCharCurrOver;
extern UINT8 BMS_FtDisCharCurrOver;
extern UINT8 BMS_FtCellTempLow;
extern UINT8 BMS_FtBranVoltDifOver;
extern UINT8 BMS_FtBMSHardWare;
extern UINT8 BMS_FtSOCHigh;
extern UINT8 BMS_FtSOCJump;
extern UINT8 BMS_FtInCom;
extern UINT8 BMS_FtSysMism;
extern UINT8 BMS_FtHvIntLock;
extern UINT8 BMS_FtSmoke;
extern UINT8 BMS_FtFire;
extern UINT8 BMS_FtNum;
extern UINT8 BMS_PackSOC;
extern UINT8 BMS_PackSOH;
extern UINT8 BMS_MaxCellTemp;
extern UINT8 BMS_MinCellTemp;
extern UINT8 BMS_AverCellTemp;
extern UINT8 BMS_MaxCellTempCSC;
extern UINT8 BMS_MaxCellTempNum;
extern UINT8 BMS_MinCellTempCSC;
extern UINT8 BMS_MinCellTempNum;
extern UINT8 BMS_MaxCellVoltCSC;
extern UINT8 BMS_MaxCellVoltNum;
extern UINT8 BMS_MinCellVoltCSC;
extern UINT8 BMS_MinCellVoltNum;
extern UINT8 BMS_InsDeteSt;
extern UINT8 BMS_FtCharInsLow;
extern UINT8 BMS_FtCurrSenr;
extern UINT8 BMS_FtHeatingFilm;
extern UINT8 BMS_FtMainLoopPreChar;
extern UINT8 BMS_FtAuxLoopPreChar;
extern UINT8 BMS_FtACANLost;
extern UINT8 BMS_FtDCDC;
extern UINT8 BMS_FtSOCDif;
extern UINT8 BMS_FtCellOverDisChar;
extern UINT8 BMS_FtCharOver;
extern UINT8 BMS_FtContDisCharCurrOverLoad;
extern UINT8 BMS_FtContCharCurrOverLoad;
extern UINT8 BMS_Gun1DCNegTemp;
extern UINT8 BMS_Gun1DCPosTemp;
extern UINT8 BMS_Gun2DCNegTemp;
extern UINT8 BMS_Gun2DCPosTemp;
extern UINT8 BMS_CurrHeatSt;
extern UINT8 BMS_CurrCoolSt;
extern UINT8 BMS_FtCharCnct;
extern UINT8 BMS_FtOverDisCharCurrDuringChar;
extern UINT8 BMS_FtCharNTC;
extern UINT8 BMS_FtELock;
extern UINT8 BMS_CellVoltFramNum;
extern UINT8 BMS_CellTempFramNum;
extern UINT8 BMS_CSC_Code;
extern UINT8 BMS_CellTemp[64];
extern UINT8 BMS_Checksum;
extern UINT8 BMS_PackComp;
extern UINT8 BMS_BattCodeLeng;
extern UINT8 BMS_SN[27];
extern UINT8 BMS_BattType;
extern UINT8 BMS_CoolType;
extern UINT8 BMS_CSC_Total;
extern UINT8 BMS_CellVoltLevel;
extern UINT8 BMS_CellMinVolt;
extern UINT8 BMS_CellMaxVolt;
extern UINT8 BMS_HVBranNum;
extern UINT8 BMS_SingleHVBranchCellNum;
extern UINT8 BMS_ReqMode;
extern UINT8 BMS_HVCmd;
extern UINT8 BMS_ChgSts;
extern UINT8 BMS_HVRelaySts;
extern UINT8 BMS_SetTemp;
extern UINT8 BMS_Life;
extern UINT8 BMS_CRC;
extern UINT8 TMS_WorkStatus;
extern UINT8 TMS_HVRelayST;
extern UINT8 TMS_OutletTemp;
extern UINT8 TMS_InletTemp;
extern UINT8 TMS_ErrCode;
extern UINT8 TMS_FaultLevel;
extern UINT16 BMS_SoftwareVersion;
extern UINT16 BMS_HardwareVersion;
extern UINT16 BMS_PackCurr;
extern UINT16 BMS_MaxCharCurr;
extern UINT16 BMS_MaxDisCharCurr;
extern UINT16 BMS_PosIns;
extern UINT16 BMS_NegIns;
extern UINT16 BMS_BattVolt;
extern UINT16 BMS_LinkVolt;
extern UINT16 BMS_MaxCellVolt;
extern UINT16 BMS_AverCellVolt;
extern UINT16 BMS_MinCellVolt;
extern UINT16 BMS_ContChrgCurr;
extern UINT16 BMS_ContDisCharCurr;
extern UINT16 BMS_CharReqVolt;
extern UINT16 BMS_CharReqCurr;
extern UINT16 BMS_SysInsRes;
extern UINT16 BMS_MaxDisCharPwr;
extern UINT16 BMS_MaxCharPwr;
extern UINT16 BMS_ContDisCharPwr;
extern UINT16 BMS_ContCharPwr;
extern UINT16 BMS_InstEngyCons;
extern UINT16 BMS_TotalEngyCons;
extern UINT16 BMS_SOE;
extern UINT16 BMS_RmanCharTime;
extern UINT16 BMS_CharNum;
extern UINT16 BMS_CellVolt[384];
extern UINT16 BMS_BattRateCap;
extern UINT16 BMS_BattRateVolt;
extern UINT16 BMS_BattRateEngy;
extern UINT16 BMS_CellTotal;
extern UINT16 BMS_TempTotal;
extern UINT16 BMS_SingleCharEngy;
extern UINT16 BMS_SingleCharCapy;
extern UINT16 BMS_HVVolt;
extern UINT16 TMS_ReqPow;
extern UINT32 BMS_TotalCharEngy;
extern UINT32 BMS_TotalDisCharEngy;
extern UINT32 BMS_TotalBackCharEngy;
extern UINT32 BMS_TotalStaCharEngy;
extern UINT32 BMS_TotalGunCharEngy;
extern UINT32 BMS_TotalGunCharCapy;
extern UINT32 BMS_TotalCharCapy;
extern UINT32 BMS_TotalDisCharCapy;
extern UINT32 BMS_TotalBackCharCapy;
extern UINT32 BMS_TotalStaCharCapy;
/*Vcu->Ebc*********************************/
extern UINT32 VcuInTable[4];
extern UINT8 VcuRxFlag[4];
extern BOOL VcuRxShortError[4];
extern BOOL VcuRxLongError[4];
extern UINT8 VcuRxErrorCounter[4];
extern UINT8 VCU_Num_VIN[17];
extern UINT8 VCU_St_VinRecv;
extern UINT8 VCU_St_BattRly;
extern UINT8 VCU_St_Check;
extern UINT8 VCU_St_SysIntLock;
extern UINT8 VCU_St_Veh;
extern UINT8 VCU_St_Gear;
extern UINT8 VCU_Ft_Sys;
extern UINT8 VCU_Ft_Tran;
extern UINT8 VCU_Ft_BattSys;
extern UINT8 VCU_State_Veh;
extern UINT8 VCU_Counter;
extern UINT8 VCU_SoftVersion;
extern UINT8 VCU_St_AccPedal;
extern UINT8 VCU_St_BrakePedal;
extern UINT8 VCU_St_ParkBrakeSw;
/**********************************/
extern UINT32 EbcOutTable[2][2];
extern UINT8 EBC_Counter;
extern UINT8 EBC_LockSt;
extern UINT8 EBC_CnctSt;
extern UINT8 EBC_DisCharCnctSt;
extern UINT8 EBC_CharCnctSt;
extern UINT8 EBC_FtLvl;
extern UINT8 EBC_FtCode;
extern UINT8 EBC_AirPressure;
extern UINT8 EBC_CharSt;
extern UINT8 EBC_ActHeatReq;
extern UINT8 EBC_InhiHVOn;
extern UINT8 EBC_ReqHVOff;
extern UINT8 EBC_StopChgCmd;
extern UINT8 EBC_State;
extern UINT8 EBC_DisCharPos1Temp;
extern UINT8 EBC_DischarNeg1Temp;
extern UINT8 EBC_DisCharPos2Temp;
extern UINT8 EBC_DisCharNeg2Temp;
extern UINT8 EBC_ChgPos1Temp;
extern UINT8 EBC_ChgNeg1Temp;
extern UINT8 EBC_ChgPos2Temp;
extern UINT8 EBC_ChgNeg2Temp;

/*************************************************************
 *Ebc->ble
 ************************************************************/
// Ble
extern uint16 bcud_E_snglChrg;		 //γ0.1kwh
extern uint16 bcud_pct_soc;			 //SOC0.1
extern uint16 bcud_Q_snglChrg;		 //γ0.1Ah
extern uint16 bcud_V_battU;			 //صѹ 0.1V
extern uint32 bcud_E_accChrg;		 //ۼƳ0.1kwh
extern uint32 bcud_E_accDischrg;	 //ۼƷŵ0.1kwh
extern uint32 bcud_E_accPlugInChrg;	 //ۼƲǹ0.1kwh
extern uint32 bcud_E_accRecovry;	 //ۼƻ0.1kwh
extern uint32 bcud_E_accSwapBatt;	 //ۼƻվ0.1kwh
extern uint32 bcud_Q_accChrg;		 //ۼƳ0.1ah
extern uint32 bcud_Q_accDischrg;	 //ۼƷŵ0.1ah
extern uint32 bcud_Q_accPlugInChrg;	 //ۼƲǹ0.1ah
extern uint32 bcud_Q_accRecovry;	 //ۼƻ0.1ah
extern uint32 bcud_Q_accSwapBatt;	 //ۼƻվ0.1ah
extern uint32 vcud_M_accDrv;		 //ۼʻ,0.1km
extern uint8 bcud_pct_bcuSoh;		 //Soh0.4%
extern uint8 bcud_st_bcuComun;		 //ͨѶ״̬,0-ͨж,1-ͨ
extern uint8 bcud_st_bcuMainRelay;	 //̵ź,0- 1-Ͽ,2-ر 3-쳣
extern uint8 bcud_st_bcuTmsLiquid;	 //ȹҺλ״̬,1-Һλ,0-Һλ
extern uint8 bcud_st_hvWork;		 //ظѹ״̬0-ѹ 1-Ԥ䣬2-ѹضϣ3-ѹϵ
extern uint8 bcuv_Num_battSn[32];	 //SN
extern uint8 ebcd_flg_pluginLockSig; //Ӳź״̬,1-,0-޴
extern uint8 ebcd_flg_swapAdmit;	 //жϣ0-,1-
extern uint8 ebcd_Nr_errMax;		 //ϵȼǰȼ
extern uint8 ebcd_Num_err1;			 //1
extern uint8 ebcd_Num_err2;			 //2
extern uint8 ebcd_st_ebcConnect;	 // EbcͨѶģʽ0-1- Ĭ0
extern uint8 ebcd_st_ebcLockWork;	 // Ebcģʽ0-ģʽ1-Զģʽ
extern uint8 ebcd_st_ebcWork;		 // Ebcǰ״̬ 0-г1-ͨѶ2-
extern uint8 ebcd_st_errTable1;		 //ϱ1bit0-ѹ쳣bit1-Һλ쳣bit2-Flashȡ쳣
extern uint8 ebcd_st_errTable2;		 //ϱ2bit0-쳣bit1-CAN쳣bit2-CAN쳣bit3-쳣bit4-쳣bit5-λ쳣
extern uint8 ebcd_st_errTable3;		 //ϱ3bit0-ŵ绥쳣bit1-绥쳣bit2-ѹ쳣
extern uint8 ebcd_st_lockSensor;	 //źţbit0-bit30-3״̬ÿbit1-0-
extern uint8 ebcd_st_lockSucJug;	 //жϣ0-ȫδ,1-ȫ,2-δȫ"
extern uint8 ebcd_st_pedstSensor;	 //bit0-bit10-1״̬,ÿbit1-0-޴
extern uint8 ebcd_st_pedstSucJug;	 //صλжϣ0-ȫδλ,1-ȫλ,2-δȫλ
extern uint8 ebcd_st_pluginLockSig;	 //Ӳźž״̬,1-,0-޴
extern uint8 ebcd_st_unlockSensor;	 //źţbit0-bit30-3״̬ÿbit1-0-
extern uint8 ebcd_st_unlockSucJug;	 //жϣ0-ȫδ1-ȫ2-δȫ
// extern uint8 vcud_P_airSensor;            //ѹѹֵλMpa0.01Mpa
extern uint8 vcud_P_airSensorBack;		  //ѹֵλMpa0.01Mpa
extern uint8 vcud_P_airSensorForward;	  //ǰѹֵλMpa0.01Mpa
extern uint8 vcud_st_carStart;			  //״̬0001-״̬0010-Ϩ0011-״̬1111-Ч
extern uint8 vcud_st_footbrake;			  //ɲźţ0-Ч1-Ч
extern uint8 vcud_st_gear;				  //λźţFF-R0-յNX-ǰDXXȡ1-12
extern uint8 vcud_st_handbrake;			  //ɲźţ0-Ч1-Ч
extern uint8 vcud_st_keyOn;				  //Կźţ1-ϵ磬0-µ
extern uint8 vcud_st_Steer;				  //źţbit0-תƣbit1-Ҳתƣÿbit 0-OFF1-ON
extern uint8 vcud_st_vcuComun;			  // vcuͨѶ״̬0-ͨж,1-ͨ
extern uint8 vcuv_Num_vin[17];			  // VIN
extern uint8 bled_flg_lockCmd;			  //ŷ1-Ч0-Ч
extern uint8 bled_flg_unlockCmd;		  //ŷ1-Ч0-Ч
extern uint8 bled_flg_lockCmdForce;		  //ŷǿ1-Ч0-Ч
extern uint8 bled_flg_unlockCmdForce;	  //ŷǿ1-Ч0-Ч
extern uint8 bled_flg_topAscendCmd;		  //1-Ч0-Ч
extern uint8 bled_flg_topDescendCmd;	  //½1-Ч0-Ч
extern uint8 bled_flg_topAscendCmdForce;  //ǿ1-Ч0-Ч
extern uint8 bled_flg_topDescendCmdForce; //ǿ½1-Ч0-Ч
extern uint8 bled_flg_openDustReCmd;	  //ָ1-Ч0-Ч
extern uint8 bled_flg_closeDustReCmd;	  //رָ1-Ч0-Ч
extern uint8 bled_flg_Heart;			  //άָ
extern uint8 bled_flg_getEbcData;		  //ȡebcָ
extern uint8 bled_flg_getVcuData;		  //ȡvcuָ
extern uint8 bled_flg_getBmsData;		  //ȡbmsָ
extern uint8 bled_flg_handShake;		  //ָ
extern uint8 bled_flg_swapBattDone;		  //ָ
extern uint8 bled_flg_backToDrv;		  //صʻ״ָ̬
extern uint8 bled_flg_autoLock;			  //Զָ
extern uint8 bled_flg_autoUnlock;		  //Զָ
extern uint8 bled_flg_toSwapMod;		  //״̬
extern uint8 bled_flg_safeStopCmd;		  //ָͣ
extern uint32 bled_Nr_softVer;			  // BLE汾
extern uint8 bled_flg_role;				  // bleģʽ 01-02-
extern uint8 bled_flg_bleConn;			  // ble״̬
extern uint8 bled_flg_bleDisconn;		  // bleϿ״̬
extern uint8 bled_st_dataTrans;			  //ݴ״̬
//ʽ
typedef enum
{
	DriveMode = 0,
	CommuMode = 1,
	SwapMode = 2
} WorkType;
extern uint8 ebcd_flg_Can2SendEnbale;
extern uint8 ebcd_st_toBleAns;
extern uint8 ebcd_P_airSensor;
extern uint8 ebcd_T_plugin[4];			//ĸӲ¶
extern uint8 ebcd_flg_forbidHVOn;		//ֹѹϵ
extern uint8 ebcb_flg_reqHvOff;			//ѹµ
extern uint8 ebcd_flg_LockErr;			//״̬
extern uint8 ebcd_flg_dChrgLockErr;		//ŵ绥״̬
extern uint8 ebcd_flg_chrgLockErr;		//绥״̬
extern uint8 ebcd_flg_dChgCnctOverTemp; //ŵ±־
extern uint8 ebcd_st_ebcWork;			// Ebcǰ״̬ 0-г1-ͨѶ2-
extern uint8 ebcd_Nr_errMax;			//ϵȼǰȼ
extern uint8 ebcd_Num_faultCode;		// ebc룬δ
extern uint8 ebcd_st_chargingMod;		//ģʽ1-س磬2-վ
extern uint8 ebdc_st_lockUpState;		//ֹ״̬0-ϣ1-ɹ2-ɹ
extern uint8 ebdc_st_ConnecState;		//״̬·&ŵ·ͬʱպϴպϣһ·ϿΪϿ0_δ 1_
extern uint8 m_flg_HVlock1;				//״̬1
extern uint8 m_flg_HVlock2;				//״̬2
extern uint16 Test_LockPressure;
#define EEPDATA_START_SEC_VAR
#include "MemMap.h"
extern uint16 ebcd_Nr_swapBatt;		  //
extern uint16 ebcd_Nr_swapSucBatt;	  //ɹ
extern uint8 ebcd_flg_ebcManCtrlEn;	  // EBCֶʹ
extern uint8 ebcd_flg_ebcManCtrlMode; // EBCֶģʽ
extern uint16 LockDelayTime;		  //ʱʱ䣨λԺʱʱȷΪɹ
extern uint16 UnlockDelayTime;		  //ʱʱ䣨λԺʱʱȷΪɹ
extern uint16 ManuControlTimes;

extern uint8 sfmv_Num_FltEEsave;
#define EEPDATA_STOP_SEC_VAR
#include "MemMap.h"
extern const uint8 T_table[240];
extern const uint32 R_table[240];
extern const uint8 DataPackCounter[21];
extern const uint8 DataPackBegin[21];
#endif /* SYSTEM_VEHICLE_COMMUNICATION_CANVAR_H_ */
